﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.3),
    on May 05, 2022, at 18:34
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.3'
expName = 'screen_scale'  # from the Builder filename that created this script
expInfo = {'participant': '', 'device type': ['Touch screen', 'Keyboard']}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\Admin\\Downloads\\screenscale_test-master (1)\\screenscale_test-master\\screen_scale_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1280, 800], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='pix')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# Initialize components for Routine "scale_set_up"
scale_set_upClock = core.Clock()
show_keys = 0
show_touch = 0
if expInfo['device type'] == 'Touch screen':
    show_touch = 1
else:
    show_keys = 1

oldt=0
x_size=8.560
y_size=5.398
screen_height=0

if win.units=='norm':
    x_scale=.05
    y_scale=.1
    dbase = .0001
    unittext=' norm units'
    vsize=2
elif win.units=='pix':
    x_scale=60
    y_scale=40
    dbase = .1
    unittext=' pixels'
    vsize=win.size[1]
else:
    x_scale=.05
    y_scale=.05
    dbase = .0001
    unittext=' height units'
    vsize=1

# Initialize components for Routine "screen_scale_keys"
screen_scale_keysClock = core.Clock()
text_top = visual.TextStim(win=win, name='text_top',
    text='Resize this image to match the size of a credit card\nUp arrow for taller\nDown arrow for shorter\nLeft arrow for narrower\nRight arrow for wider',
    font='Arial',
    units='norm', pos=(0, .7), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
text_bottom = visual.TextStim(win=win, name='text_bottom',
    text='Press the space bar when done',
    font='Arial',
    units='norm', pos=(0, -.6), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);
ccimage = visual.ImageStim(
    win=win,
    name='ccimage', 
    image='bank-1300155_640.png', mask=None, anchor='center',
    ori=0, pos=(0, 0), size=(x_size*x_scale, y_size*y_scale),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-3.0)

# Initialize components for Routine "rectangle_keys"
rectangle_keysClock = core.Clock()
rectangle_text_keys = visual.TextStim(win=win, name='rectangle_text_keys',
    text='This shape should be a 10 cm square.\nComponent size  (10*x_scale, 10*y_scale) set every repeat.\nPress space to continue.',
    font='Arial',
    units='norm', pos=(0, -.8), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
polygon_keys = visual.Rect(
    win=win, name='polygon_keys',
    width=[1.0, 1.0][0], height=[1.0, 1.0][1],
    ori=0, pos=(0, 0), anchor='center',
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-1.0, interpolate=True)
key_resp_keys = keyboard.Keyboard()

# Initialize components for Routine "screen_scale_touch"
screen_scale_touchClock = core.Clock()
text_top_touch = visual.TextStim(win=win, name='text_top_touch',
    text='Resize this image to match the size of a credit card by clicking/tapping the arrows:\nUp = taller\nDown = shorter\nLeft = narrower\nRight = wider',
    font='Arial',
    units='norm', pos=(0, .7), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
tri_up = visual.ShapeStim(
    win=win, name='tri_up',units='height', 
    size=(0.1, 0.1), vertices='triangle',
    ori=0.0, pos=(-0.55, 0.35), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=1.0, depth=-2.0, interpolate=True)
tri_down = visual.ShapeStim(
    win=win, name='tri_down',units='height', 
    size=(0.1, 0.1), vertices='triangle',
    ori=180.0, pos=(-0.55, 0.2), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=1.0, depth=-3.0, interpolate=True)
tri_right = visual.ShapeStim(
    win=win, name='tri_right',units='height', 
    size=(0.1, 0.1), vertices='triangle',
    ori=90.0, pos=(0.65, 0.3), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=1.0, depth=-4.0, interpolate=True)
tri_left = visual.ShapeStim(
    win=win, name='tri_left',units='height', 
    size=(0.1, 0.1), vertices='triangle',
    ori=270.0, pos=(0.5, 0.3), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=1.0, depth=-5.0, interpolate=True)
ccimage_touch = visual.ImageStim(
    win=win,
    name='ccimage_touch', 
    image='bank-1300155_640.png', mask=None, anchor='center',
    ori=0, pos=(0, 0), size=1.0,
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-6.0)
continue_button = visual.ImageStim(
    win=win,
    name='continue_button', units='height', 
    image='continue.png', mask=None, anchor='center',
    ori=0.0, pos=(0.65, -0.45), size=(0.25, 0.07),
    color=[1,1,1], colorSpace='rgb', opacity=1.0,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-7.0)
mouse = event.Mouse(win=win)
x, y = [None, None]
mouse.mouseClock = core.Clock()
text_bottom_touch = visual.TextStim(win=win, name='text_bottom_touch',
    text='',
    font='Arial',
    units='norm', pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-9.0);

# Initialize components for Routine "rectangle_touch"
rectangle_touchClock = core.Clock()
rectangle_text_touch = visual.TextStim(win=win, name='rectangle_text_touch',
    text='This shape should be a 10 cm square.\nComponent size  (10*x_scale, 10*y_scale) set every repeat.\nClick or touch here to continue.',
    font='Arial',
    units='norm', pos=(0, -.8), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
polygon = visual.Rect(
    win=win, name='polygon',
    width=[1.0, 1.0][0], height=[1.0, 1.0][1],
    ori=0, pos=(0, 0), anchor='center',
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-1.0, interpolate=True)
mouse_end = event.Mouse(win=win)
x, y = [None, None]
mouse_end.mouseClock = core.Clock()

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "scale_set_up"-------
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
scale_set_upComponents = []
for thisComponent in scale_set_upComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
scale_set_upClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "scale_set_up"-------
while continueRoutine:
    # get current time
    t = scale_set_upClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=scale_set_upClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in scale_set_upComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "scale_set_up"-------
for thisComponent in scale_set_upComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "scale_set_up" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
key_scale = data.TrialHandler(nReps=show_keys, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='key_scale')
thisExp.addLoop(key_scale)  # add the loop to the experiment
thisKey_scale = key_scale.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisKey_scale.rgb)
if thisKey_scale != None:
    for paramName in thisKey_scale:
        exec('{} = thisKey_scale[paramName]'.format(paramName))

for thisKey_scale in key_scale:
    currentLoop = key_scale
    # abbreviate parameter names if possible (e.g. rgb = thisKey_scale.rgb)
    if thisKey_scale != None:
        for paramName in thisKey_scale:
            exec('{} = thisKey_scale[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "screen_scale_keys"-------
    continueRoutine = True
    # update component parameters for each repeat
    print('key start')
    event.clearEvents()
    
    
    # keep track of which components have finished
    screen_scale_keysComponents = [text_top, text_bottom, ccimage]
    for thisComponent in screen_scale_keysComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    screen_scale_keysClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "screen_scale_keys"-------
    while continueRoutine:
        # get current time
        t = screen_scale_keysClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=screen_scale_keysClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        keys=event.getKeys()
        
        if len(keys):
            if t-oldt<.5:
                dscale=5*dbase
                oldt=t
            else:
                dscale=dbase
                oldt=t
            if 'space' in keys and t > 1:
                continueRoutine=False
            elif 'up' in keys:
                y_scale=round((y_scale+dscale)*10000)/10000
            elif 'down' in keys:
                y_scale=round((y_scale-dscale)*10000)/10000
            elif 'left' in keys:
                x_scale=round((x_scale-dscale)*10000)/10000
            elif 'right' in keys:
                x_scale=round((x_scale+dscale)*10000)/10000
            screen_height=round(vsize*10/y_scale)/10
            text_bottom.text='X Scale = '+str(x_scale)+unittext+' per cm, Y Scale = '+str(y_scale)+unittext+' per cm\nScreen height = '+str(screen_height)+' cm\n\nPress the space bar when done'
            ccimage.size=[x_size*x_scale, y_size*y_scale]
            
        
        # *text_top* updates
        if text_top.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_top.frameNStart = frameN  # exact frame index
            text_top.tStart = t  # local t and not account for scr refresh
            text_top.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_top, 'tStartRefresh')  # time at next scr refresh
            text_top.setAutoDraw(True)
        
        # *text_bottom* updates
        if text_bottom.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_bottom.frameNStart = frameN  # exact frame index
            text_bottom.tStart = t  # local t and not account for scr refresh
            text_bottom.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_bottom, 'tStartRefresh')  # time at next scr refresh
            text_bottom.setAutoDraw(True)
        
        # *ccimage* updates
        if ccimage.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ccimage.frameNStart = frameN  # exact frame index
            ccimage.tStart = t  # local t and not account for scr refresh
            ccimage.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ccimage, 'tStartRefresh')  # time at next scr refresh
            ccimage.setAutoDraw(True)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in screen_scale_keysComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "screen_scale_keys"-------
    for thisComponent in screen_scale_keysComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    thisExp.addData('X Scale',x_scale)
    thisExp.addData('Y Scale',y_scale)
    
    key_scale.addData('ccimage.started', ccimage.tStartRefresh)
    key_scale.addData('ccimage.stopped', ccimage.tStopRefresh)
    # the Routine "screen_scale_keys" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "rectangle_keys"-------
    continueRoutine = True
    # update component parameters for each repeat
    polygon_keys.setSize((10*x_scale, 10*y_scale))
    key_resp_keys.keys = []
    key_resp_keys.rt = []
    _key_resp_keys_allKeys = []
    # keep track of which components have finished
    rectangle_keysComponents = [rectangle_text_keys, polygon_keys, key_resp_keys]
    for thisComponent in rectangle_keysComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    rectangle_keysClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "rectangle_keys"-------
    while continueRoutine:
        # get current time
        t = rectangle_keysClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=rectangle_keysClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *rectangle_text_keys* updates
        if rectangle_text_keys.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            rectangle_text_keys.frameNStart = frameN  # exact frame index
            rectangle_text_keys.tStart = t  # local t and not account for scr refresh
            rectangle_text_keys.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(rectangle_text_keys, 'tStartRefresh')  # time at next scr refresh
            rectangle_text_keys.setAutoDraw(True)
        
        # *polygon_keys* updates
        if polygon_keys.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygon_keys.frameNStart = frameN  # exact frame index
            polygon_keys.tStart = t  # local t and not account for scr refresh
            polygon_keys.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygon_keys, 'tStartRefresh')  # time at next scr refresh
            polygon_keys.setAutoDraw(True)
        
        # *key_resp_keys* updates
        waitOnFlip = False
        if key_resp_keys.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_resp_keys.frameNStart = frameN  # exact frame index
            key_resp_keys.tStart = t  # local t and not account for scr refresh
            key_resp_keys.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_keys, 'tStartRefresh')  # time at next scr refresh
            key_resp_keys.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_keys.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_keys.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_keys.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_keys.getKeys(keyList=['space'], waitRelease=False)
            _key_resp_keys_allKeys.extend(theseKeys)
            if len(_key_resp_keys_allKeys):
                key_resp_keys.keys = _key_resp_keys_allKeys[-1].name  # just the last key pressed
                key_resp_keys.rt = _key_resp_keys_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in rectangle_keysComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "rectangle_keys"-------
    for thisComponent in rectangle_keysComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "rectangle_keys" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
# completed show_keys repeats of 'key_scale'


# set up handler to look after randomisation of conditions etc
touch_trials = data.TrialHandler(nReps=show_touch, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='touch_trials')
thisExp.addLoop(touch_trials)  # add the loop to the experiment
thisTouch_trial = touch_trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTouch_trial.rgb)
if thisTouch_trial != None:
    for paramName in thisTouch_trial:
        exec('{} = thisTouch_trial[paramName]'.format(paramName))

for thisTouch_trial in touch_trials:
    currentLoop = touch_trials
    # abbreviate parameter names if possible (e.g. rgb = thisTouch_trial.rgb)
    if thisTouch_trial != None:
        for paramName in thisTouch_trial:
            exec('{} = thisTouch_trial[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "screen_scale_touch"-------
    continueRoutine = True
    # update component parameters for each repeat
    print('touch start')
    event.clearEvents()
    text_bottom_touch_text = ' hello world'
    # setup some python lists for storing info about the mouse
    mouse.x = []
    mouse.y = []
    mouse.leftButton = []
    mouse.midButton = []
    mouse.rightButton = []
    mouse.time = []
    mouse.clicked_name = []
    gotValidClick = False  # until a click is received
    mouse.mouseClock.reset()
    # keep track of which components have finished
    screen_scale_touchComponents = [text_top_touch, tri_up, tri_down, tri_right, tri_left, ccimage_touch, continue_button, mouse, text_bottom_touch]
    for thisComponent in screen_scale_touchComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    screen_scale_touchClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "screen_scale_touch"-------
    while continueRoutine:
        # get current time
        t = screen_scale_touchClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=screen_scale_touchClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        click = mouse.clicked_name
        
        if len(click):
            if t-oldt<.5:
                dscale=5*dbase
                oldt=t
            else:
                dscale=dbase
                oldt=t
            if mouse.isPressedIn(continue_button) and t > 1:
                continueRoutine=False
            elif mouse.isPressedIn(tri_up):
                y_scale=round((y_scale+dscale)*10000)/10000
            elif mouse.isPressedIn(tri_down):
                y_scale=round((y_scale-dscale)*10000)/10000
            elif mouse.isPressedIn(tri_left):
                x_scale=round((x_scale-dscale)*10000)/10000
            elif mouse.isPressedIn(tri_right):
                x_scale=round((x_scale+dscale)*10000)/10000
            screen_height=round(vsize*10/y_scale)/10
            text_bottom_touch_text='X Scale = '+str(x_scale)+unittext+' per cm, Y Scale = '+str(y_scale)+unittext+' per cm\nScreen height = '+str(screen_height)+' cm'
            ccimage_touch.size=[x_size*x_scale, y_size*y_scale]
        
        
        
        # *text_top_touch* updates
        if text_top_touch.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_top_touch.frameNStart = frameN  # exact frame index
            text_top_touch.tStart = t  # local t and not account for scr refresh
            text_top_touch.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_top_touch, 'tStartRefresh')  # time at next scr refresh
            text_top_touch.setAutoDraw(True)
        
        # *tri_up* updates
        if tri_up.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            tri_up.frameNStart = frameN  # exact frame index
            tri_up.tStart = t  # local t and not account for scr refresh
            tri_up.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(tri_up, 'tStartRefresh')  # time at next scr refresh
            tri_up.setAutoDraw(True)
        
        # *tri_down* updates
        if tri_down.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            tri_down.frameNStart = frameN  # exact frame index
            tri_down.tStart = t  # local t and not account for scr refresh
            tri_down.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(tri_down, 'tStartRefresh')  # time at next scr refresh
            tri_down.setAutoDraw(True)
        
        # *tri_right* updates
        if tri_right.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            tri_right.frameNStart = frameN  # exact frame index
            tri_right.tStart = t  # local t and not account for scr refresh
            tri_right.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(tri_right, 'tStartRefresh')  # time at next scr refresh
            tri_right.setAutoDraw(True)
        
        # *tri_left* updates
        if tri_left.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            tri_left.frameNStart = frameN  # exact frame index
            tri_left.tStart = t  # local t and not account for scr refresh
            tri_left.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(tri_left, 'tStartRefresh')  # time at next scr refresh
            tri_left.setAutoDraw(True)
        
        # *ccimage_touch* updates
        if ccimage_touch.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ccimage_touch.frameNStart = frameN  # exact frame index
            ccimage_touch.tStart = t  # local t and not account for scr refresh
            ccimage_touch.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ccimage_touch, 'tStartRefresh')  # time at next scr refresh
            ccimage_touch.setAutoDraw(True)
        if ccimage_touch.status == STARTED:  # only update if drawing
            ccimage_touch.setSize((x_size*x_scale, y_size*y_scale), log=False)
        
        # *continue_button* updates
        if continue_button.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            continue_button.frameNStart = frameN  # exact frame index
            continue_button.tStart = t  # local t and not account for scr refresh
            continue_button.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(continue_button, 'tStartRefresh')  # time at next scr refresh
            continue_button.setAutoDraw(True)
        # *mouse* updates
        if mouse.status == NOT_STARTED and t >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            mouse.frameNStart = frameN  # exact frame index
            mouse.tStart = t  # local t and not account for scr refresh
            mouse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(mouse, 'tStartRefresh')  # time at next scr refresh
            mouse.status = STARTED
            prevButtonState = mouse.getPressed()  # if button is down already this ISN'T a new click
        if mouse.status == STARTED:  # only update if started and not finished!
            x, y = mouse.getPos()
            mouse.x.append(x)
            mouse.y.append(y)
            buttons = mouse.getPressed()
            mouse.leftButton.append(buttons[0])
            mouse.midButton.append(buttons[1])
            mouse.rightButton.append(buttons[2])
            mouse.time.append(mouse.mouseClock.getTime())
        
        # *text_bottom_touch* updates
        if text_bottom_touch.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_bottom_touch.frameNStart = frameN  # exact frame index
            text_bottom_touch.tStart = t  # local t and not account for scr refresh
            text_bottom_touch.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_bottom_touch, 'tStartRefresh')  # time at next scr refresh
            text_bottom_touch.setAutoDraw(True)
        if text_bottom_touch.status == STARTED:  # only update if drawing
            text_bottom_touch.setText(text_bottom_touch_text, log=False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in screen_scale_touchComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "screen_scale_touch"-------
    for thisComponent in screen_scale_touchComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    thisExp.addData('X Scale',x_scale)
    thisExp.addData('Y Scale',y_scale)
    
    touch_trials.addData('tri_up.started', tri_up.tStartRefresh)
    touch_trials.addData('tri_up.stopped', tri_up.tStopRefresh)
    touch_trials.addData('tri_down.started', tri_down.tStartRefresh)
    touch_trials.addData('tri_down.stopped', tri_down.tStopRefresh)
    touch_trials.addData('tri_right.started', tri_right.tStartRefresh)
    touch_trials.addData('tri_right.stopped', tri_right.tStopRefresh)
    touch_trials.addData('tri_left.started', tri_left.tStartRefresh)
    touch_trials.addData('tri_left.stopped', tri_left.tStopRefresh)
    touch_trials.addData('ccimage_touch.started', ccimage_touch.tStartRefresh)
    touch_trials.addData('ccimage_touch.stopped', ccimage_touch.tStopRefresh)
    touch_trials.addData('continue_button.started', continue_button.tStartRefresh)
    touch_trials.addData('continue_button.stopped', continue_button.tStopRefresh)
    # store data for touch_trials (TrialHandler)
    touch_trials.addData('mouse.x', mouse.x)
    touch_trials.addData('mouse.y', mouse.y)
    touch_trials.addData('mouse.leftButton', mouse.leftButton)
    touch_trials.addData('mouse.midButton', mouse.midButton)
    touch_trials.addData('mouse.rightButton', mouse.rightButton)
    touch_trials.addData('mouse.time', mouse.time)
    touch_trials.addData('mouse.clicked_name', mouse.clicked_name)
    touch_trials.addData('mouse.started', mouse.tStart)
    touch_trials.addData('mouse.stopped', mouse.tStop)
    touch_trials.addData('text_bottom_touch.started', text_bottom_touch.tStartRefresh)
    touch_trials.addData('text_bottom_touch.stopped', text_bottom_touch.tStopRefresh)
    # the Routine "screen_scale_touch" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "rectangle_touch"-------
    continueRoutine = True
    # update component parameters for each repeat
    polygon.setSize((10*x_scale, 10*y_scale))
    # setup some python lists for storing info about the mouse_end
    mouse_end.x = []
    mouse_end.y = []
    mouse_end.leftButton = []
    mouse_end.midButton = []
    mouse_end.rightButton = []
    mouse_end.time = []
    mouse_end.clicked_name = []
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    rectangle_touchComponents = [rectangle_text_touch, polygon, mouse_end]
    for thisComponent in rectangle_touchComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    rectangle_touchClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "rectangle_touch"-------
    while continueRoutine:
        # get current time
        t = rectangle_touchClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=rectangle_touchClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *rectangle_text_touch* updates
        if rectangle_text_touch.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            rectangle_text_touch.frameNStart = frameN  # exact frame index
            rectangle_text_touch.tStart = t  # local t and not account for scr refresh
            rectangle_text_touch.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(rectangle_text_touch, 'tStartRefresh')  # time at next scr refresh
            rectangle_text_touch.setAutoDraw(True)
        
        # *polygon* updates
        if polygon.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygon.frameNStart = frameN  # exact frame index
            polygon.tStart = t  # local t and not account for scr refresh
            polygon.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygon, 'tStartRefresh')  # time at next scr refresh
            polygon.setAutoDraw(True)
        # *mouse_end* updates
        if mouse_end.status == NOT_STARTED and t >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            mouse_end.frameNStart = frameN  # exact frame index
            mouse_end.tStart = t  # local t and not account for scr refresh
            mouse_end.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(mouse_end, 'tStartRefresh')  # time at next scr refresh
            mouse_end.status = STARTED
            mouse_end.mouseClock.reset()
            prevButtonState = mouse_end.getPressed()  # if button is down already this ISN'T a new click
        if mouse_end.status == STARTED:  # only update if started and not finished!
            buttons = mouse_end.getPressed()
            if buttons != prevButtonState:  # button state changed?
                prevButtonState = buttons
                if sum(buttons) > 0:  # state changed to a new click
                    # check if the mouse was inside our 'clickable' objects
                    gotValidClick = False
                    try:
                        iter(rectangle_text_touch)
                        clickableList = rectangle_text_touch
                    except:
                        clickableList = [rectangle_text_touch]
                    for obj in clickableList:
                        if obj.contains(mouse_end):
                            gotValidClick = True
                            mouse_end.clicked_name.append(obj.name)
                    x, y = mouse_end.getPos()
                    mouse_end.x.append(x)
                    mouse_end.y.append(y)
                    buttons = mouse_end.getPressed()
                    mouse_end.leftButton.append(buttons[0])
                    mouse_end.midButton.append(buttons[1])
                    mouse_end.rightButton.append(buttons[2])
                    mouse_end.time.append(mouse_end.mouseClock.getTime())
                    if gotValidClick:
                        continueRoutine = False  # abort routine on response
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in rectangle_touchComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "rectangle_touch"-------
    for thisComponent in rectangle_touchComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # store data for touch_trials (TrialHandler)
    touch_trials.addData('mouse_end.x', mouse_end.x)
    touch_trials.addData('mouse_end.y', mouse_end.y)
    touch_trials.addData('mouse_end.leftButton', mouse_end.leftButton)
    touch_trials.addData('mouse_end.midButton', mouse_end.midButton)
    touch_trials.addData('mouse_end.rightButton', mouse_end.rightButton)
    touch_trials.addData('mouse_end.time', mouse_end.time)
    touch_trials.addData('mouse_end.clicked_name', mouse_end.clicked_name)
    touch_trials.addData('mouse_end.started', mouse_end.tStart)
    touch_trials.addData('mouse_end.stopped', mouse_end.tStop)
    # the Routine "rectangle_touch" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
# completed show_touch repeats of 'touch_trials'


# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
